Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.event
Class StartTagBuffer

    java.lang.Object
      net.sf.saxon.event.SequenceReceiver
          net.sf.saxon.event.ProxyReceiver
              net.sf.saxon.event.StartTagBuffer

All Implemented Interfaces:
  Result, Receiver, NamespaceResolver

Direct Known Subclasses:
  IDFilter, StartTagBufferEE

    public class StartTagBuffer

extends ProxyReceiver
implements NamespaceResolver

StartTagBuffer is a ProxyReceiver that buffers attributes and namespace events within a start tag. It maintains details of the namespace context, and a full set of attribute information, on behalf of other filters that need access to namespace information or need to process attributes in arbitrary order.

StartTagBuffer also implements namespace fixup (the process of creating namespace nodes|bindings on behalf of constructed element and attribute nodes). Although this would be done anyway, further down the pipeline, it has to be done early in the case of a validating pipeline, because the namespace bindings must be created before any namespace-sensitive attribute content is validated.

The StartTagBuffer also allows error conditions to be buffered. This is because the XSIAttributeHandler validates attributes such as xsi:type and xsi:nil before attempting to match its parent element against a particle of its containing type. It is possible that the parent element will match a wildcard particle with processContents="skip", in which case an invalid xsi:type or xsi:nil attribute is not an error.

Field Summary
`protected AttributeCollectionImpl` | `bufferedAttributes`
`protected int` | `elementLocationId`
`protected NodeName` | `elementNameCode`
`protected int` | `elementProperties`
`protected SchemaType` | `elementTypeCode`
`protected NamespaceBinding[]` | `namespaces`
`protected int` | `namespacesSize`

Fields inherited from class net.sf.saxon.event.ProxyReceiver
`nextReceiver`

Fields inherited from class net.sf.saxon.event.SequenceReceiver
`pipelineConfiguration, previousAtomic, systemId`

Fields inherited from interface javax.xml.transform.Result
`PI_DISABLE_OUTPUT_ESCAPING, PI_ENABLE_OUTPUT_ESCAPING`

Constructor Summary
`StartTagBuffer(Receiver next)`

Method Summary
`void` | `attribute(NodeName attName, SimpleType typeCode, CharSequence value, int locationId, int properties)` Notify an attribute.
`protected void` | `declareAllNamespaces()` Signal namespace events for all in-scope namespaces to the current receiver in the pipeline
`protected void` | `declareNamespacesForStartElement()`
`void` | `endDocument()` Notify the end of a document node
`void` | `endElement()` endElement: Discard the namespaces declared locally on this element.
`AttributeCollection` | `getAllAttributes()` Get all the attributes on the current element start tag
`String` | `getAttribute(int nameCode)` Get the value of the current attribute with a given nameCode
`NamespaceBinding[]` | `getLocalNamespaces()` Get the namespaces declared (or undeclared) at the current level
`String` | `getURIForPrefix(String prefix, boolean useDefault)` Get the namespace URI corresponding to a given prefix.
`boolean` | `hasAttributes()` Determine if the current element has any attributes
`Iterator<String>` | `iteratePrefixes()` Get an iterator over all the prefixes declared in this namespace context.
`void` | `namespace(NamespaceBinding namespaceBinding, int properties)` Notify a namespace.
`void` | `setPipelineConfiguration(PipelineConfiguration pipe)` Set the pipeline configuration
`void` | `startContent()` startContent: Add any namespace undeclarations needed to stop namespaces being inherited from parent elements
`void` | `startDocument(int properties)` Start of a document node.
`void` | `startElement(NodeName nameCode, SchemaType typeCode, int locationId, int properties)` startElement
`protected void` | `undeclareNamespacesForElement()`

Methods inherited from class net.sf.saxon.event.ProxyReceiver
`append, characters, close, comment, getNamePool, getUnderlyingReceiver, open, processingInstruction, setSystemId, setUnderlyingReceiver, setUnparsedEntity, usesTypeAnnotations`

Methods inherited from class net.sf.saxon.event.SequenceReceiver
`append, getConfiguration, getPipelineConfiguration, getSystemId`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### elementNameCode

    protected NodeName elementNameCode

### elementTypeCode

    protected SchemaType elementTypeCode

### elementLocationId

    protected int elementLocationId

### elementProperties

    protected int elementProperties

### bufferedAttributes

    protected AttributeCollectionImpl bufferedAttributes

### namespaces

    protected NamespaceBinding[] namespaces

### namespacesSize

    protected int namespacesSize

Constructor Detail

### StartTagBuffer

    public StartTagBuffer(Receiver next)

Method Detail

### setPipelineConfiguration

    public void setPipelineConfiguration(PipelineConfiguration pipe)

  Set the pipeline configuration

  Specified by:
    `setPipelineConfiguration` in interface `Receiver`
  Overrides:
    `setPipelineConfiguration` in class `ProxyReceiver`
  Parameters:
    `pipe` - the pipeline configuration

### startDocument

    public void startDocument(int properties)
                       throws XPathException

  Start of a document node.

  Specified by:
    `startDocument` in interface `Receiver`
  Overrides:
    `startDocument` in class `ProxyReceiver`
  Parameters:
    `properties` - bit-significant integer indicating properties of the document node. The definitions of the bits are in class `ReceiverOptions`
  Throws:
    `XPathException` - if an error occurs

### endDocument

    public void endDocument()
                     throws XPathException

  Notify the end of a document node

  Specified by:
    `endDocument` in interface `Receiver`
  Overrides:
    `endDocument` in class `ProxyReceiver`
  Throws:
    `XPathException` - if an error occurs

### startElement

    public void startElement(NodeName nameCode,
                             SchemaType typeCode,
                             int locationId,
                             int properties)
                      throws XPathException

  startElement

  Specified by:
    `startElement` in interface `Receiver`
  Overrides:
    `startElement` in class `ProxyReceiver`
  Parameters:
    `nameCode` - integer code identifying the name of the element within the name pool.
    `typeCode` - integer code identifying the element's type within the name pool.
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
    `properties` - properties of the element node
  Throws:
    `XPathException` - if an error occurs

### namespace

    public void namespace(NamespaceBinding namespaceBinding,
                          int properties)
                   throws XPathException

  Description copied from class: `ProxyReceiver`
  Notify a namespace. Namespaces are notified after the startElement event, and before any children for the element. The namespaces that are reported are only required to include those that are different from the parent element; however, duplicates may be reported. A namespace must not conflict with any namespaces already used for element or attribute names.

  Specified by:
    `namespace` in interface `Receiver`
  Overrides:
    `namespace` in class `ProxyReceiver`
  Parameters:
    `namespaceBinding` - the prefix/uri pair representing the namespace binding
    `properties` - any special properties to be passed on this call
  Throws:
    `XPathException` - if an error occurs

### attribute

    public void attribute(NodeName attName,
                          SimpleType typeCode,
                          CharSequence value,
                          int locationId,
                          int properties)
                   throws XPathException

  Notify an attribute. Attributes are notified after the startElement event, and before any children. Namespaces and attributes may be intermingled.

  Specified by:
    `attribute` in interface `Receiver`
  Overrides:
    `attribute` in class `ProxyReceiver`
  Parameters:
    `attName` - The name of the attribute, as held in the name pool
    `typeCode` - The type of the attribute, as held in the name pool
    `properties` - Bit significant value. The following bits are defined:
    DISABLE_ESCAPING
  Disable escaping for this attribute
    NO_SPECIAL_CHARACTERS
  Attribute value contains no special characters
    `value` - the string value of the attribute
    `locationId` - an integer which can be interpreted using a `LocationProvider` to return information such as line number and system ID. If no location information is available, the value zero is supplied.
  Throws:
    `IllegalStateException:` - attempt to output an attribute when there is no open element start tag
    `XPathException` - if an error occurs

### startContent

    public void startContent()
                      throws XPathException

  startContent: Add any namespace undeclarations needed to stop namespaces being inherited from parent elements

  Specified by:
    `startContent` in interface `Receiver`
  Overrides:
    `startContent` in class `ProxyReceiver`
  Throws:
    `XPathException` - if an error occurs

### declareNamespacesForStartElement

    protected void declareNamespacesForStartElement()
                                             throws XPathException

  Throws:
    `XPathException`

### getLocalNamespaces

    public NamespaceBinding[] getLocalNamespaces()

  Get the namespaces declared (or undeclared) at the current level

  Returns:
    an array of namespace bindings

### declareAllNamespaces

    protected void declareAllNamespaces()
                                 throws XPathException

  Signal namespace events for all in-scope namespaces to the current receiver in the pipeline

  Throws:
    `XPathException` - if any downstream error occurs

### endElement

    public void endElement()
                    throws XPathException

  endElement: Discard the namespaces declared locally on this element.

  Specified by:
    `endElement` in interface `Receiver`
  Overrides:
    `endElement` in class `ProxyReceiver`
  Throws:
    `XPathException` - if an error occurs

### undeclareNamespacesForElement

    protected void undeclareNamespacesForElement()

### hasAttributes

    public boolean hasAttributes()

  Determine if the current element has any attributes

  Returns:
    true if the element has one or more attributes

### getAttribute

    public String getAttribute(int nameCode)

  Get the value of the current attribute with a given nameCode

  Parameters:
    `nameCode` - the name of the required attribute
  Returns:
    the attribute value, or null if the attribute is not present

### getAllAttributes

    public AttributeCollection getAllAttributes()

  Get all the attributes on the current element start tag

  Returns:
    an AttributeCollection containing all the attributes

### getURIForPrefix

    public String getURIForPrefix(String prefix,
                                  boolean useDefault)

  Get the namespace URI corresponding to a given prefix. Return null if the prefix is not in scope. f

  Specified by:
    `getURIForPrefix` in interface `NamespaceResolver`
  Parameters:
    `prefix` - the namespace prefix
    `useDefault` - true if the default namespace is to be used when the prefix is ""
  Returns:
    the uri for the namespace, or null if the prefix is not in scope

### iteratePrefixes

    public Iterator<String> iteratePrefixes()

  Get an iterator over all the prefixes declared in this namespace context. This will include the default namespace (prefix="") and the XML namespace where appropriate

  Specified by:
    `iteratePrefixes` in interface `NamespaceResolver`
  Returns:
    an iterator over all the prefixes for which a namespace binding exists, including the zero-length string to represent the null/absent prefix if it is bound

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.